<template>
    <div class="content-grid content-grid--subpage">
        <Breadcrumbs :title="t(`routes.admin.children.regles.edit.name`)" />
        <BackLinkTitle :title="t(`routes.admin.children.regles.edit.name`)" />
        <Card>
            <RegleForm :regle="regle" ref="regleFormRef" @formSubmit="handleSubmit" />
        </Card>
    </div>
</template>

<script lang="ts" setup>
import {useI18n} from "vue3-i18n";
    import { notifyError, notifySuccess } from "@/notify";
    import { useRegleService } from "@/inversify.config";
    import { useRouter } from "vue-router";
    import { Regle } from "@/types/entities";
import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
    import BackLinkTitle from "@/components/layout/BackLinkTitle.vue";
    import RegleForm from "@/components/regles/RegleForm.vue";
import Card from "@/components/layout/Card.vue";
    import { ref } from "vue";
    import { IEditRegleRequest } from "@/types/requests/editRegleRequest";

// eslint-disable-next-line no-undef
const props = defineProps<{
    id: string
}>();

const {t} = useI18n()
    const router = useRouter();
    const regleService = useRegleService();
    const regleFormRef = ref();


    const regle = ref<Regle>(await regleService.getRegle(props.id));

    async function handleSubmit(regle: Regle) {
        let succeededOrNotResponse = await regleService.editRegle(regle as IEditRegleRequest)
    if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
        notifySuccess(t('validation.regle.edit.success'))
        setTimeout(() => {
            router.back();
        }, 1500);
    } else {
        let errorMessages = succeededOrNotResponse.getErrorMessages('validation.regle.edit');
        if (errorMessages.length == 0)
            notifyError(t('validation.regle.edit.errorOccured'))
        else {
            if (regleFormRef.value) {
                regleFormRef.value.mettreRouge();
            }
            notifyError(errorMessages[0])

        }
    }
}
</script>
